//(C) Clyde Meli 2008-2009
//code offered with NO WARRANTY
// I make no warranty, guarantee or make any representations regarding the use, results of use, accuracy, 
// timeliness or completeness of any data or information relating to the code. I disclaim all warranties, express 
// or implied, and in particular, disclaim all warranties of merchantability, fitness for a particular purpose, and 
// warranties related to the code, or any service or software related thereto.
//
// I will not be liable for any direct, indirect or consequential damages or costs of any type arising out of any 
// action taken by you or others related to the code
namespace OxyFlash;

interface

uses
  System.Drawing,
  System.Collections,
  System.Collections.Generic,
  System.Linq,
  System.Windows.Forms,
  COMInterface,
  SWFObjs; //for the COM object!

// you need to c:\...\tlbimp /namespace:SWFObjs swfobjs.dll
// and also to regsvr32 swfobjs.dll
// add reference to SWFOBJSLib.dll in sol'n explorer

type
  /// <summary>
  /// Summary description for MainForm.
  /// </summary>

  MainForm = partial class(System.Windows.Forms.Form)
  private
      method button1_Click(sender: System.Object; e: System.EventArgs);
  protected
    method Dispose(disposing: Boolean); override;
  public
    constructor;
  end;

  
implementation

{$REGION Construction and Disposition}
constructor MainForm;
begin
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent();

  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

method MainForm.Dispose(disposing: Boolean);
begin
  if disposing then begin
    if assigned(components) then
      components.Dispose();

    //
    // TODO: Add custom disposition code here
    //
  end;
  inherited Dispose(disposing);
end;
{$ENDREGION}



method MainForm.button1_Click(sender: System.Object; e: System.EventArgs);
const filename = 'sample.swf';
var vv, txt, obj: object;
    ii: integer;     
    com,comv,comt:ComCall;       

begin
  comv:=new ComCall;
  comt:=new ComCall;
  com:=new ComCall;
  try 
    vv:=comv.ComInvoke('swfObjs.swfMovie',"SetSize",comv.SetParam(6400,3700));
  
    obj := com.ComInvoke('swfObjs.swfObject',"MakeRectangle",com.SetParam(0,0,6380,3680));
    
    com.ComInvoke('SetRadialFill',com.SetParam(42, 42, 255, 255, 255, 224, 224, 255));
    com.ComInvoke('SetRadialFillCenter',com.SetParam(3190, 1895));
    com.ComInvoke('SetDepth',com.SetParam(0));
    
    comv.AddObject(obj);
    //vv.AddObject(obj);--delphi

    com.ComInvoke('MakeFont',com.SetParam("MyFont"));
    com.ComInvoke('AddGlyph',com.SetParam('Arial', 'Ta Xbiex.com', ord('T')));
    
    
    txt := comt.ComInvoke('swfObjs.swfObject','MakeText',comt.SetParam("MT",obj)); 
    comt.ComInvoke('translate',comt.SetParam(500, 1500)); 
    comt.ComInvoke('SetSolidFill',comt.SetParam(0, 255, 0, 250)); //start colours r g b
    comt.ComInvoke('Scale',comt.SetParam(65536 div 2, 65536 div 2));

    
    comv.AddObject(txt);     //vv.AddObject(txt);--delphi
      
    for ii := 10 to 50 do begin
        comv.ComInvoke('GotoFrame',comv.SetParam(ii));
        
        if ii >= 10 then comv.RemoveObject(txt);
        comt.ComInvoke('Rotate',comt.SetParam((50-ii)*65536 * 9));
        comt.ComInvoke('Scale',comt.SetParam((60-ii)*6553,(60-ii)*6553));
        comt.ComInvoke('SetSolidFill',comt.SetParam(0, 255, 0, (ii-9)*5));//end colours
                    
        comv.AddObject(txt);             //vv.AddObject(txt);
        
  end;

    
    comv.ComInvoke('WriteMovie',comv.SetParam(filename));
    
  except
      on Ex: ArgumentNullException do
      Begin
        MessageBox.Show('Argument must not be null! Exception occured.');
        raise;
      End;
  end;
    MessageBox.Show('Finished!');
    
end;

end.